PeatInfoDisplay = {};

function PeatInfoDisplay:loadMap(name)
	g_currentMission.hud.fieldInfoDisplay.displayLabelText = g_i18n:getText("peat_info")
	FieldInfoDisplay.onFieldDataUpdateFinished = PeatInfoDisplay.onFieldDataUpdateFinished;
end

function PeatInfoDisplay:deleteMap()
end

function PeatInfoDisplay:draw(dt)
end;

function PeatInfoDisplay:update(dt)
end;

function PeatInfoDisplay:onFieldDataUpdateFinished(data)
    if not self.requestedFieldData then
        return -- discard results of update in some cases, e.g. reset
    end
    local hasData = data ~= nil
    if hasData then
        self:clearFieldData()
        self:setFarmlandOwnerFarmId(data.farmlandId, data.ownerFarmId)
        local fruitIndex = 0
        local fruitState = 0
        local maxPixels = 0
        for fruitDescIndex, state in pairs(data.fruits) do
            if data.fruitPixels[fruitDescIndex] > maxPixels then
                maxPixels = data.fruitPixels[fruitDescIndex]
                fruitIndex = fruitDescIndex
                fruitState = state
            end
        end
        PeatInfoDisplay:setFruitType(fruitIndex, fruitState,self)
    end
    self.requestedFieldData = false
    self:setVisible(hasData and self.player.isEntered)
end

function PeatInfoDisplay:setFruitType(fruitTypeIndex, fruitGrowthState,self)
    local fruitTypeRow = self.rows[FieldInfoDisplay.INFO_TYPE.FRUIT_TYPE]
    local fieldStateRow = self.rows[FieldInfoDisplay.INFO_TYPE.FIELD_STATE]
    
	if fruitTypeIndex == self.fruitTypeManager:getFruitTypeByName("PEAT").index then
        local fruitType = self.fruitTypeManager:getFruitTypeByIndex(fruitTypeIndex)
		fruitTypeRow.leftText = g_i18n:getText("peat")
		local rText = ""
		if fruitGrowthState > fruitType.minPreparingGrowthState then
			rText = g_i18n:getText("ready_to_turn")
		end
        fruitTypeRow.rightText = rText
		
		fieldStateRow.leftText = g_i18n:getText("damp")
		fieldStateRow.rightText = g_i18n:getText("damp_state_" .. fruitGrowthState)	
	elseif fruitTypeIndex == self.fruitTypeManager:getFruitTypeByName("PEAT_TURNED").index then
        local fruitType = self.fruitTypeManager:getFruitTypeByIndex(fruitTypeIndex)
		if fruitGrowthState == fruitType.cutState + 1 then
	        self:clearInfoRow(fruitTypeRow)
			self:clearInfoRow(fieldStateRow)
		else
			fruitTypeRow.leftText = g_i18n:getText("peat")
			local rText = ""
			if fruitGrowthState > fruitType.minHarvestingGrowthState then
				rText = g_i18n:getText("ready_to_pick")
			end
			fruitTypeRow.rightText = rText
			
			fieldStateRow.leftText = g_i18n:getText("damp")
			fieldStateRow.rightText = g_i18n:getText("damp_state_" .. (fruitGrowthState + 3))	
		end
    else
        self:clearInfoRow(fruitTypeRow)
        self:clearInfoRow(fieldStateRow)
    end
    self.needResize = true
end

addModEventListener(PeatInfoDisplay)
