peatCollector = {}

function peatCollector.prerequisitesPresent(specializations)
	return true;
end

function peatCollector.registerEventListeners(vehicleType)

end 


function peatCollector.registerOverwrittenFunctions(vehicleType)
    SpecializationUtil.registerOverwrittenFunction(vehicleType, "processMowerArea",    peatCollector.processMowerArea)
end

function peatCollector:processMowerArea(superFunc, workArea, dt)
    local spec = self.spec_mower
    if self:getLastSpeed() > 1 then
        spec.isWorking = true
    end
    local xs,_,zs = getWorldTranslation(workArea.start)
    local xw,_,zw = getWorldTranslation(workArea.width)
    local xh,_,zh = getWorldTranslation(workArea.height)
	
	
	local lsx, lsy, lsz, lex, ley, lez, radius = DensityMapHeightUtil.getLineByArea(workArea.start, workArea.width, workArea.height)
	pickupLiters = -DensityMapHeightUtil.tipToGroundAroundLine(self, -math.huge, FillType.PEAT_WINDROW, lsx,lsy,lsz, lex,ley,lez, radius, nil, nil, false, nil)

	
    --for inputFruitType, converterData in pairs(spec.fruitTypeConverters) do
	local inputFruitType = FruitType.PEAT_TURNED	
	local changedArea, totalArea, sprayFactor, plowFactor, limeFactor, weedFactor, _, _ = FSDensityMapUtil.cutFruitArea(inputFruitType, xs,zs, xw,zw, xh,zh, true, true, false)
	local litersToDrop = pickupLiters;
	
	if changedArea > 0 then
		local multiplier = 1  --g_currentMission:getHarvestScaleMultiplier(inputFruitType, sprayFactor, plowFactor, limeFactor, weedFactor)
		changedArea = changedArea * multiplier
		local pixelToSqm = g_currentMission:getFruitPixelsToSqm()
		local sqm = changedArea * pixelToSqm
		litersToDrop = litersToDrop + sqm * g_fruitTypeManager:getFillTypeLiterPerSqm(FillType.PEAT_WINDROW, 1)
	end
	if litersToDrop > 0 then
		workArea.lastPickupLiters = litersToDrop
		local dropArea = self:getDropArea(workArea)
		if dropArea ~= nil then
			dropArea.litersToDrop = dropArea.litersToDrop + litersToDrop
			dropArea.fillType = FillType.PEAT_WINDROW
			dropArea.workAreaIndex = workArea.index
		elseif spec.fillUnitIndex ~= nil then
			if self.isServer then
				self:addFillUnitFillLevel(self:getOwnerFarmId(), spec.fillUnitIndex, litersToDrop, FillType.PEAT_WINDROW, ToolType.UNDEFINED)
			end
		end
		spec.workAreaParameters.lastChangedArea = spec.workAreaParameters.lastChangedArea + changedArea
		spec.workAreaParameters.lastStatsArea = spec.workAreaParameters.lastStatsArea + changedArea
		spec.workAreaParameters.lastTotalArea   = spec.workAreaParameters.lastTotalArea + totalArea
		spec.workAreaParameters.lastUsedAreas = spec.workAreaParameters.lastUsedAreas + 1
	end

    spec.workAreaParameters.lastUsedAreasSum = spec.workAreaParameters.lastUsedAreasSum + 1
    return spec.workAreaParameters.lastChangedArea, spec.workAreaParameters.lastTotalArea
end